'use strict';

var ws = require('websocket-stream');

var makeRpcPlugin = require('./shared');

module.exports = {
  name: 'rpc-client',
  plugin: makeRpcPlugin(websocketClient)
};

function websocketClient(core, opts, handle) {
  var websocket = ws(opts.url);
  handle(websocket);
  websocket.on('error', function (err) {
    return console.log('ws error', err);
  });
  if (typeof window !== 'undefined') window.addEventListener('beforeunload', function () {
    return websocket.close();
  });
}
