'use strict';

var avvio = require('avvio');

var util = require('./lib/util');

var nanobus = require('nanobus');

module.exports = ucore;

function ucore(opts) {
  var ucore = {};
  var bus = nanobus();
  var app = avvio(ucore);
  ucore.plugins = [];
  ucore.decorate = util.makeDecorate(ucore);

  ucore.register = function (plugin, opts) {
    ucore.plugins.push(plugin);
    ucore.use(plugin.plugin, opts);
  }; // ucore.decorate('bus', bus)


  ucore.on = bus.on.bind(bus);
  ucore.emit = bus.emit.bind(bus);
  ucore.once = bus.once.bind(bus);

  ucore.debug = function () {};

  ucore.isReady = false;
  app.on('start', function () {
    ucore.isReady = true;
    bus.emit('ready');
  });
  return ucore;
}
