'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var __chunk_1 = require('./chunk-fa9342c3.js');

// import React from 'react'
// import shallowEqual from 'shallowequal'
var React = require('react');

var shallowEqual = require('shallowequal');

var cleanProps = function cleanProps(props) {
  var children = props.children,
      store = props.store,
      select = props.select,
      init = props.init,
      rest = __chunk_1._objectWithoutProperties(props, ["children", "store", "select", "init"]);

  return rest;
};

var Subscriber =
/*#__PURE__*/
function (_React$Component) {
  __chunk_1._inherits(Subscriber, _React$Component);

  function Subscriber(props) {
    var _this;

    __chunk_1._classCallCheck(this, Subscriber);

    _this = __chunk_1._possibleConstructorReturn(this, __chunk_1._getPrototypeOf(Subscriber).call(this));
    var sel = props.store.select(props.select, cleanProps(props));
    _this.state = {
      sel: sel
    };
    _this.onUpdate = _this.onUpdate.bind(__chunk_1._assertThisInitialized(__chunk_1._assertThisInitialized(_this)));
    return _this;
  }

  __chunk_1._createClass(Subscriber, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.subscribe();
    }
  }, {
    key: "subscribe",
    value: function subscribe() {
      if (this.unsubscribe) this.unsubscribe();
      this.unsubscribe = this.props.store.subscribe(this.onUpdate, this.props.select, cleanProps(this.props));

      if (this.props.init) {
        this.props.store.actions[this.props.init](cleanProps(this.props));
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.unsubscribe();
    }
  }, {
    key: "onUpdate",
    value: function onUpdate(sel) {
      this.setState({
        sel: sel
      });
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      // Always update on prop change.
      if (!shallowEqual(cleanProps(this.props), cleanProps(nextProps))) return true; // Never update if state is the same.

      if (shallowEqual(this.state.sel, nextState.sel)) return false;
      return true;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      if (!shallowEqual(prevProps, this.props)) this.subscribe();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          store = _this$props.store;
      var sel = this.state.sel;
      return typeof children === 'function' ? children(sel, store) : children;
    }
  }]);

  return Subscriber;
}(React.Component);
var Context = React.createContext();
var Provider = function Provider(_ref) {
  var core = _ref.core,
      children = _ref.children;
  return React.createElement(Context.Provider, {
    value: core
  }, children);
};
var Consumer =
/*#__PURE__*/
function (_React$PureComponent) {
  __chunk_1._inherits(Consumer, _React$PureComponent);

  function Consumer() {
    __chunk_1._classCallCheck(this, Consumer);

    return __chunk_1._possibleConstructorReturn(this, __chunk_1._getPrototypeOf(Consumer).apply(this, arguments));
  }

  __chunk_1._createClass(Consumer, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          store = _this$props2.store,
          rest = __chunk_1._objectWithoutProperties(_this$props2, ["store"]);

      return React.createElement(WithCore, null, function (core) {
        return React.createElement(Subscriber, __chunk_1._extends({
          store: core.getStore(store)
        }, rest));
      });
    }
  }]);

  return Consumer;
}(React.PureComponent);

var AsyncCoreProxy =
/*#__PURE__*/
function (_React$PureComponent2) {
  __chunk_1._inherits(AsyncCoreProxy, _React$PureComponent2);

  function AsyncCoreProxy() {
    __chunk_1._classCallCheck(this, AsyncCoreProxy);

    return __chunk_1._possibleConstructorReturn(this, __chunk_1._getPrototypeOf(AsyncCoreProxy).apply(this, arguments));
  }

  __chunk_1._createClass(AsyncCoreProxy, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      if (!this.props.core.isReady) this.props.core.on('ready', function () {
        return _this2.forceUpdate();
      });
    }
  }, {
    key: "render",
    value: function render() {
      if (!this.props.core.isReady) return React.createElement("div", null, "Loading");
      return this.props.children(this.props.core);
    }
  }]);

  return AsyncCoreProxy;
}(React.PureComponent);

var WithCore =
/*#__PURE__*/
function (_React$PureComponent3) {
  __chunk_1._inherits(WithCore, _React$PureComponent3);

  function WithCore() {
    __chunk_1._classCallCheck(this, WithCore);

    return __chunk_1._possibleConstructorReturn(this, __chunk_1._getPrototypeOf(WithCore).apply(this, arguments));
  }

  __chunk_1._createClass(WithCore, [{
    key: "render",
    value: function render() {
      var children = this.props.children;
      return React.createElement(Context.Consumer, null, function (core) {
        return core.isReady ? children(core) : React.createElement(AsyncCoreProxy, {
          core: core,
          children: children
        });
      });
    }
  }]);

  return WithCore;
}(React.PureComponent);
var WithStore =
/*#__PURE__*/
function (_React$PureComponent4) {
  __chunk_1._inherits(WithStore, _React$PureComponent4);

  function WithStore() {
    __chunk_1._classCallCheck(this, WithStore);

    return __chunk_1._possibleConstructorReturn(this, __chunk_1._getPrototypeOf(WithStore).apply(this, arguments));
  }

  __chunk_1._createClass(WithStore, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          store = _this$props3.store,
          children = _this$props3.children;
      return React.createElement(WithCore, null, function (core) {
        var realStore = core.getStore(store);
        return children(realStore);
      });
    }
  }]);

  return WithStore;
}(React.PureComponent);

exports.Subscriber = Subscriber;
exports.Provider = Provider;
exports.Consumer = Consumer;
exports.WithCore = WithCore;
exports.WithStore = WithStore;
