import babel from 'rollup-plugin-babel'
import resolve from 'rollup-plugin-node-resolve'
import commonjs from 'rollup-plugin-commonjs'
import replace from 'rollup-plugin-replace'

export default {
  input: ['index.js', 'rpc/client.js', 'rpc/server.js', 'store/index.js', 'react/index.js'],
  output: {
    dir: 'dist',
    format: 'cjs'
  },
  experimentalCodeSplitting: true,
  plugins: [
    replace({ 'process.env.NODE_ENV': JSON.stringify('production') }),
    resolve({
      browser: true
    }),
    commonjs({
      include: 'node_modules/**',
      namedExports: {
      }
    }),
    babel({
      exclude: 'node_modules/**'
    })
  ],
  external: ['react', 'react-dom']
}
